*** eprints-3.0.2-beta-3/lib/defaultcfg/cfg.d/user_fields.pl	Wed Jun 13 16:13:51 2007
--- eprints-3.0.2-patched/lib/defaultcfg/cfg.d/user_fields.pl	Fri Jun 29 12:07:31 2007
***************
*** 5,10 ****
--- 5,13 ----
              'name' => 'name',
              'type' => 'name',
              'render_order' => 'gf',
+ # comment the next line if prompt for the name in "given" "family" order
+             'family_first' => 1,
+             'render_single_value' => \&my_name_rendering,
            },
  
            {
***************
*** 52,54 ****
--- 55,107 ----
              'type' => 'url',
            }
  ]; 
+ 
+ # Rendering names depending on the session language
+ # define the format for all used languages
+ # format: h l f g  are honourific, lineage, first and given
+ # other characters appear in the string as they come
+ 
+ sub my_name_rendering {
+ 	my($session,$field,$value,$object) =@_;
+ 
+ #  the default ordering can be produced by
+ #    $session->render_name($value,$field->{render_order});
+ 
+ 	my $langid = $session->{lang}->{id};
+ 	my $format = { 
+ 		'en'=> "hfl,g", # Dr Sammy Jr, David
+ 		'hu'=> "hlfg" 
+ 	} -> { $langid };
+ 	my $all="";
+ 	foreach my $fmtchar (split //, $format )
+ 	{
+ 		my $insert;
+ 		if($fmtchar eq "l")
+ 		{
+ 			$insert = $value->{lineage};
+ 		}
+ 		elsif ($fmtchar eq "f")
+ 		{
+ 			$insert = $value->{family};
+ 		}
+ 		elsif ($fmtchar eq "g")
+ 		{
+ 			$insert = $value->{given};
+ 		}
+ 		elsif ($fmtchar eq "h")
+ 		{
+ 			$insert = $value->{honourific};
+ 		}
+ 		elsif( $all )
+ 		{
+ 			$all .= $fmtchar;
+ 		}
+ 		next if(! $insert );
+ 		$all .= ' ' if($all);
+ 		$all .= $insert;
+ 	}
+ 	my $span=$session->make_element("span",class=>"person_name");
+ 	$span->appendChild($session->make_text($all ));
+ 	return $span;
+ }
+ 
